﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class GameManager : MonoBehaviour
{
    [SerializeField] GameObject wallsObj;
    [SerializeField] Vector3 wallPosition;

    [SerializeField] TurnManager turnMan;

    GameObject currentWall;
    public GameObject[] walls;

    float probability;
    float luckyHit;
    float multiplierLucky = 20f;

    int current = 0;

    float time;
    bool gameEnd = false;

    int player1;
    int player2;

    bool lucky = false;

    float hit = 25f;


    // Start is called before the first frame update
    void Start()
    {
        walls = new GameObject[5];
        for (int i = 0; i < 5; i++)
        {
            walls[i] = wallsObj.transform.GetChild(i).gameObject;
            Debug.Log(walls[i].name);
        }

        currentWall = Instantiate(walls[0], wallPosition, Quaternion.identity);
    }

    // Update is called once per frame
    void Update()
    {
<<<<<<< Updated upstream
        if (current == 4)
        {
            PlayerPrefs.SetString("Player 1", player1.ToString());
            PlayerPrefs.SetString("Player 2", player2.ToString());

            SceneManager.LoadScene(2);
            //StartCoroutine("WaitForBroken");
        }
=======

>>>>>>> Stashed changes
    }


    //Breaks or keeps wall the same depending on hit probability
    public void DestroyWall()
    {
        if (current > (walls.Length - 1))
        {
            Destroy(currentWall, 0f);
            currentWall = Instantiate(walls[walls.Length - 1], wallPosition, Quaternion.identity);
        }
        else
        {
            Destroy(currentWall, 0f);
            currentWall = Instantiate(walls[current], wallPosition, Quaternion.identity);
        }

    }


    //Gets new index depending on probability
    private void GetIterations()
    {

        if (current == 0)
        {
            FirstPhase();
        }
        else if (current == 1)
        {
            SecondPhase();
        }
        else if (current == 2)
        {
            ThirdPhase();
        }
        else if (current == 3)
        {
            FourthPhase();
        }
        else
        {
<<<<<<< Updated upstream

        }

=======
            
        }
       
>>>>>>> Stashed changes
    }

    //recieve time for charged hit
    public void ReceiveStrike(float current, float max)
    {
        time = current;
    }


    //use charge time to scale wall damage
    public void ChargeTheThing()
    {

        if (time <= 1f)
        {

        }
        else if (1f < time && time <= 2f)
        {
            probability = probability * 1.20f;
        }
        else if (2f < time && time <= 3f)
        {
            probability = probability * 1.40f;
        }
        else if (3f < time && time <= 4f)
        {
            probability = probability * 1.60f;
        }
        else if (time > 4f)
        {
            probability = probability * 1.80f;
        }
    }

    //
    public void LuckyHit()
    {
        luckyHit = Random.Range(0f, 50f);

        if (time <= 1f)
        {

        }
        else if (1f < time && time <= 2f)
        {
            if (1f < luckyHit && luckyHit <= 3f)
            {
                lucky = true;
            }
        }
        else if (2f < time && time <= 3f)
        {
            if (3f < luckyHit && luckyHit <= 10f)
            {
                lucky = true;
            }
        }
        else if (3f < time && time <= 4f)
        {
            if (10f < luckyHit && luckyHit <= 25f)
            {
                lucky = true;
            }
        }
        else if (time > 4f)
        {
            if (25f < luckyHit)
            {
                lucky = true;
            }
        }
    }

    private void AddHit()
    {
        probability = Random.Range(0f, 100f);

        ChargeTheThing();
        GetIterations();
        LuckyHit();

        if (GetPhase() == 0)
        {

        }
        else if (GetPhase() == 1)
        {
            hit = hit * 1.25f;

        }

        else if (GetPhase() == 2)
        {
            hit = hit * 1.50f;

        }

        else if (GetPhase() == 3)
        {
            hit = hit * 1.75f;

        }

        //multiply luck hit if it happened
        if (lucky == true)
        {
            hit = hit * multiplierLucky;
        }


        //record score
        if (turnMan.GetTurnNum() % 2 == 1)
        {
            player1 += (int)Mathf.Round(hit);
<<<<<<< Updated upstream
            Debug.Log("Player 1" + player1.ToString());
            
=======
>>>>>>> Stashed changes
        }
        else
        {
            player2 += (int)Mathf.Round(hit);
<<<<<<< Updated upstream
            Debug.Log("Player 2" + player2.ToString());
        }

        Debug.Log(current);
=======
        }

        if(current == 5)
        {
            StartCoroutine("WaitForBroken");
        }
>>>>>>> Stashed changes

        DestroyWall();
        turnMan.NextTurn();
    }

    //game ended
    public void Lose()
    {
<<<<<<< Updated upstream
        
=======
        DestroyWall();

        PlayerPrefs.SetString("Player 1", player1.ToString());
        PlayerPrefs.SetString("Player 2", player2.ToString());

        SceneManager.LoadScene(2);
>>>>>>> Stashed changes
    }

    //get phase
    public int GetPhase()
    {
        return current;
    }

    //First Phase percentages
    private void FirstPhase()
    {
        if (probability <= 15)
        {

        }
        else if (probability > 15 && probability <= 66)
        {
            current += 1;
        }
        else if (probability > 66 && probability <= 90)
        {
            current += 2;
        }
        else if (probability > 90 && probability <= 97)
        {
            current += 3;
        }
        else if (probability > 97)
        {
<<<<<<< Updated upstream

=======
            
>>>>>>> Stashed changes
        }
    }

    //Second Phase percentages
    private void SecondPhase()
    {
        if (probability <= 50)
        {

        }
        else if (probability > 51 && probability <= 76)
        {
            current += 1;
        }
        else if (probability > 76 && probability <= 95)
        {
            current += 2;
        }
        else if (probability > 95)
        {
            current += 3;
        }
    }

    //Third Phase Percentages
    private void ThirdPhase()
    {
        if (probability <= 34)
        {

        }
        else if (probability > 34 && probability <= 67)
        {
            current += 1;
        }
        else if (probability > 67)
        {
            current += 2;
        }
    }

    //Fourth Phase percentages
    private void FourthPhase()
    {
        if (probability <= 25)
        {

        }
        else
        {
            current += 1;
        }
    }

<<<<<<< Updated upstream
    /*IEnumerator WaitForBroken()
    {
        Lose();
        yield return new WaitForSeconds(2);
    }*/

    void OnTriggerEnter2D(Collider2D col)
    {
        AddHit();
        Debug.Log("Hit");
    }



=======
    IEnumerator WaitForBroken()
    {
        yield return new WaitForSeconds(2);
        Lose();
    }
        
       
>>>>>>> Stashed changes
}





   
